Wt: Wt::WTreeNode Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WTreeNode Class Reference

A single node in a tree. More...

`#include <Wt/WTreeNode.h>`

Inheritance diagram for Wt::WTreeNode:
[legend]

## Public Member Functions
| WTreeNode (const WString &labelText, std::unique_ptr< WIconPair > labelIcon=nullptr)
| Creates a tree node with the given label.
| ~WTreeNode ()
| Destructor.
virtual WTree * | tree () const
| Returns the tree.
WText * | label () const
| Returns the label.
WIconPair * | labelIcon () const
| Returns the label icon.
void | setLabelIcon (std::unique_ptr< WIconPair > labelIcon)
| Sets the label icon.
virtual void | insertChildNode (int index, std::unique_ptr< WTreeNode > node)
| Inserts a child node.
WTreeNode * | addChildNode (std::unique_ptr< WTreeNode > node)
| Adds a child node.
std::unique_ptr< WTreeNode > | removeChildNode (WTreeNode *node)
| Removes a child node.
std::vector< WTreeNode * > | childNodes () const
| Returns the list of children.
virtual int | displayedChildCount () const
| Returns the number of children that should be displayed.
void | setChildCountPolicy (ChildCountPolicy policy)
| Configures how and when the child count should be displayed.
ChildCountPolicy | childCountPolicy () const
| Returns the child count policy.
void | setLoadPolicy (ContentLoading loadPolicy)
| Sets the load policy for this tree.
bool | isExpanded () const
| Returns whether this node is expanded.
virtual void | setSelectable (bool selectable) override
| Allows this node to be selected.
virtual bool | isSelectable () const
| Returns if this node may be selected.
WTreeNode * | parentNode () const
| Returns the parent node.
void | setNodeVisible (bool visible)
| Sets the visibility of the node itself.
void | setChildrenDecorated (bool decorated)
| Sets whether this node's children are decorated.
void | setInteractive (bool interactive)
| Sets whether this node is interactive.
void | expand ()
| Expands this node.
void | collapse ()
| Collapses this node.
EventSignal< WMouseEvent > & | expanded ()
| Signal emitted when the node is expanded by the user.
EventSignal< WMouseEvent > & | collapsed ()
| Signal emitted when the node is collapsed by the user.
Signal< bool > & | selected ()
| Signal that is emitted when the node is added or removed from the selection
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
| WTreeNode ()
| Creates a tree node with empty labelArea().
WContainerWidget * | labelArea () const
| Accesses the container widget that holds the label area.
virtual void | populate ()
| Populates the node dynamically on loading.
bool | populated () const
| Returns whether this node has already been populated.
virtual bool | expandable ()
| Returns whether this node can be expanded.
virtual void | renderSelected (bool selected)
| Renders the node to be selected.
virtual void | descendantRemoved (WTreeNode *node)
| Reacts to the removal of a descendant node.
virtual void | descendantAdded (WTreeNode *node)
| Reacts to the addition of a descendant node.
virtual void | doExpand ()
| The actual expand.
virtual void | doCollapse ()
| The actual collapse.
virtual void | undoDoExpand ()
| Undo method for doCollapse() stateless implementation.
virtual void | undoDoCollapse ()
| Undo method for doCollapse() stateless implementation.
WIconPair * | expandIcon () const
| Accesses the icon pair that allows expansion of the tree node.
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A single node in a tree.

A tree list is constructed by combining several tree node objects in a tree hierarchy, by passing the parent tree node as the last argument in the child node constructor, or by using addChildNode(), to add a child to its parent.

Each tree node has a label, and optionally a label icon pair. The icon pair offers the capability to show a different icon depending on the state of the node (expanded or collapsed). When the node has any children, a child count may be displayed next to the label using setChildCountPolicy().

Expanding a tree node it will collapse all its children, so that a user may collapse/expand a node as a short-cut to collapsing all children.

The treenode provides several policies to communicate the current contents of the tree to the client (if possible):

- ContentLoading::Eager: the entire tree is transmitted to the client, and all tree navigation requires no further communication.
- ContentLoading::Lazy: only the minimum is transmitted to the client. When expanding a node for the first time, only then it is transmitted to the client, and this may thus have some latency.
- ContentLoading::NextLevel: all leafs of visible children are transmitted, but not their children. This provides a good trade-off between bandwith use and interactivity, since expanding any tree node will happen instantly, and at the same time trigger some communication in the back-ground to load the next level of invisible nodes.

The default policy is ContentLoading::Lazy. Another load policy may be specified using setLoadPolicy() on the root node and before adding any children. The load policy is inherited by all children in the tree.

There are a few scenarios where it makes sense to specialize the WTreeNode class. One scenario is create a tree that is populated dynamically while browsing. For this purpose you should reimplement the populate() method, whose default implementation does nothing. This method is called when 'loading' the node. The exact moment for loading a treenode depends on the LoadPolicy.

A second scenario that is if you want to customize the look of the tree label (see labelArea()) or if you want to modify or augment the event collapse/expand event handling (see doExpand() and doCollapse()).

See WTree for a usage example.

See also
  WTree, WTreeTableNode

## Constructor & Destructor Documentation

## ◆ WTreeNode() [1/2]

Wt::WTreeNode::WTreeNode | ( | const WString & | labelText,
|  | std::unique_ptr< WIconPair > | labelIcon = nullptr )

Creates a tree node with the given label.

The labelIcon, if specified, will appear just before the label and its state reflect the expand/collapse state of the node.

The node is initialized to be collapsed.

## ◆ WTreeNode() [2/2]

Wt::WTreeNode::WTreeNode | ( |  | ) |
| protected

Creates a tree node with empty labelArea().

This tree node has no label or labelicon, and is therefore ideally suited to provide a custom look.

## Member Function Documentation

## ◆ addChildNode()

WTreeNode * Wt::WTreeNode::addChildNode | ( | std::unique_ptr< WTreeNode > | node | ) |

Adds a child node.

Equivalent to:

insertChildNode(childNodes().size(), std::move(node));
Wt::WTreeNode::childNodes
std::vector< WTreeNode * > childNodes() const
Returns the list of children.
Wt::WTreeNode::insertChildNode
virtual void insertChildNode(int index, std::unique_ptr< WTreeNode > node)
Inserts a child node.

See also
  insertChildNode()

## ◆ childCountPolicy()

ChildCountPolicy Wt::WTreeNode::childCountPolicy | ( |  | ) | const

Returns the child count policy.

See also
  setChildCountPolicy(ChildCountPolicy policy)

## ◆ collapse()

void Wt::WTreeNode::collapse | ( |  | ) |

Collapses this node.

See also
  expand()
  doCollapse()

## ◆ collapsed()

EventSignal< WMouseEvent > & Wt::WTreeNode::collapsed | ( |  | ) |

Signal emitted when the node is collapsed by the user.

See also
  expanded()

## ◆ descendantAdded()

virtual void Wt::WTreeNode::descendantAdded | ( | WTreeNode * | node | ) |
| protectedvirtual

Reacts to the addition of a descendant node.

Reimplement this method if you wish to react on the addition of a descendant node. The default implementation simply propagates the event to the parent.

## ◆ descendantRemoved()

virtual void Wt::WTreeNode::descendantRemoved | ( | WTreeNode * | node | ) |
| protectedvirtual

Reacts to the removal of a descendant node.

Reimplement this method if you wish to react on the removal of a descendant node. The default implementation simply propagates the event to the parent.

## ◆ displayedChildCount()

virtual int Wt::WTreeNode::displayedChildCount | ( |  | ) | const
| virtual

Returns the number of children that should be displayed.

This is used to display the count in the count label. The default implementation simply returns childNodes().size().

## ◆ doCollapse()

virtual void Wt::WTreeNode::doCollapse | ( |  | ) |
| protectedvirtual

The actual collapse.

This method, which is implemented as a stateless slot, performs the actual collapse of the node.

You may want to reimplement this function (and undoDoCollapse()) if you wish to do additional things on node expansion.

See also
  doExpand()
  collapse()

## ◆ doExpand()

virtual void Wt::WTreeNode::doExpand | ( |  | ) |
| protectedvirtual

The actual expand.

This method, which is implemented as a stateless slot, performs the actual expansion of the node.

You may want to reimplement this function (and undoDoExpand()) if you wish to do additional things on node expansion.

See also
  doCollapse()
  expand()

## ◆ expand()

void Wt::WTreeNode::expand | ( |  | ) |

Expands this node.

Besides the actual expansion of the node, this may also trigger the loading and population of the node children, or of the children's children.

See also
  collapse()
  doExpand()

## ◆ expandable()

virtual bool Wt::WTreeNode::expandable | ( |  | ) |
| protectedvirtual

Returns whether this node can be expanded.

The default implementation populates the node if necessary, and then checks if there are any child nodes.

You may wish to reimplement this method if you reimplement populate(), and you have a quick default for determining whether a node may be expanded (which does not require populating the node).

See also
  populate()

## ◆ expanded()

EventSignal< WMouseEvent > & Wt::WTreeNode::expanded | ( |  | ) |

Signal emitted when the node is expanded by the user.

See also
  collapsed()

## ◆ insertChildNode()

virtual void Wt::WTreeNode::insertChildNode | ( | int | index,
|  | std::unique_ptr< WTreeNode > | node )
| virtual

Inserts a child node.

Inserts the node `node` at index `index`.

Reimplemented in Wt::WTreeTableNode.

## ◆ isSelectable()

virtual bool Wt::WTreeNode::isSelectable | ( |  | ) | const
| virtual

Returns if this node may be selected.

See also
  setSelectable(bool)

## ◆ labelArea()

WContainerWidget * Wt::WTreeNode::labelArea | ( |  | ) | const
| protected

Accesses the container widget that holds the label area.

Use this to customize how the label should look like.

## ◆ parentNode()

WTreeNode * Wt::WTreeNode::parentNode | ( |  | ) | const

Returns the parent node.

See also
  childNodes()

## ◆ populate()

virtual void Wt::WTreeNode::populate | ( |  | ) |
| protectedvirtual

Populates the node dynamically on loading.

Reimplement this method if you want to populate the widget dynamically, as the tree is being browsed and therefore loaded. This is only usefull with LazyLoading or NextLevelLoading strategies.

## ◆ populated()

bool Wt::WTreeNode::populated | ( |  | ) | const
| protected

Returns whether this node has already been populated.

See also
  populate()

## ◆ renderSelected()

virtual void Wt::WTreeNode::renderSelected | ( | bool | selected | ) |
| protectedvirtual

Renders the node to be selected.

The default implementation changes the style class of the labelArea() to "selected".

## ◆ selected()

Signal< bool > & Wt::WTreeNode::selected | ( |  | ) |

Signal that is emitted when the node is added or removed from the selection

See also
  WTree::itemSelectionChanged

## ◆ setChildCountPolicy()

void Wt::WTreeNode::setChildCountPolicy | ( | ChildCountPolicy | policy | ) |

Configures how and when the child count should be displayed.

By default, no child count indication is disabled (this is the behaviour since 2.1.1). Use this method to enable child count indications.

The child count policy is inherited by all children in the tree.

## ◆ setChildrenDecorated()

void Wt::WTreeNode::setChildrenDecorated | ( | bool | decorated | ) |

Sets whether this node's children are decorated.

By default, node's children have expand/collapse and other lines to display their linkage and offspring.

By setting `decorated` to `false`, you can hide the decorations for the node's children.

## ◆ setInteractive()

void Wt::WTreeNode::setInteractive | ( | bool | interactive | ) |

Sets whether this node is interactive.

Interactive nodes can be clicked upon and will populate a list of children when clicked. By disabling the interactivity, a node will not react to a click event.

## ◆ setLoadPolicy()

void Wt::WTreeNode::setLoadPolicy | ( | ContentLoading | loadPolicy | ) |

Sets the load policy for this tree.

This may only be set on the root of a tree, and before adding any children.

## ◆ setNodeVisible()

void Wt::WTreeNode::setNodeVisible | ( | bool | visible | ) |

Sets the visibility of the node itself.

If `false`, then the node itself is not displayed, but only its children. This is typically used to hide the root node of a tree.

## ◆ setSelectable()

virtual void Wt::WTreeNode::setSelectable | ( | bool | selectable | ) |
| overridevirtual

Allows this node to be selected.

By default, all nodes may be selected.

See also
  isSelectable(), WTree::select(WTreeNode *, bool)

Reimplemented from Wt::WCompositeWidget.

## ◆ tree()

virtual WTree * Wt::WTreeNode::tree | ( |  | ) | const
| virtual

Returns the tree.

By default if this node has no parent the result will be 0.

## ◆ undoDoCollapse()

virtual void Wt::WTreeNode::undoDoCollapse | ( |  | ) |
| protectedvirtual

Undo method for doCollapse() stateless implementation.

See also
  doExpand()

## ◆ undoDoExpand()

virtual void Wt::WTreeNode::undoDoExpand | ( |  | ) |
| protectedvirtual

Undo method for doCollapse() stateless implementation.

See also
  doCollapse()